

/****** Object:  Table [dbo].[ActionPhoto]    Script Date: 8/6/2021 12:08:22 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[ActionPhoto](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[PhotoPath] [nvarchar](200) NOT NULL,
	[RoadActionId] [int] NOT NULL,
 CONSTRAINT [PK_ActionPhoto] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[ActionType]    Script Date: 8/6/2021 12:08:22 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[ActionType](
	[Id] [int] NOT NULL,
	[Name] [nvarchar](50) NOT NULL,
	[BackColorHex] [nchar](7) NOT NULL,
	[FontColorHex] [nchar](7) NOT NULL,
	[IsEmergencyEvent] [bit] NOT NULL,
 CONSTRAINT [PK_ActionType] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Branch]    Script Date: 8/6/2021 12:08:22 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Branch](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[Name] [nvarchar](50) NULL,
	[LocationLongitude] [decimal](9, 6) NOT NULL,
	[LocationLatitude] [decimal](8, 6) NOT NULL,
 CONSTRAINT [PK_Branch] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Driver]    Script Date: 8/6/2021 12:08:22 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Driver](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[FullName] [nvarchar](100) NOT NULL,
	[DateOfBirth] [date] NOT NULL,
	[Phone] [nvarchar](20) NOT NULL,
	[Picture] [image] NULL,
	[MedicalHealthRestriction] [int] NULL,
 CONSTRAINT [PK_Driver] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[DriverOfTruck]    Script Date: 8/6/2021 12:08:22 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[DriverOfTruck](
	[DriverId] [int] NOT NULL,
	[TruckId] [int] NOT NULL,
 CONSTRAINT [PK_DriverOfTruck] PRIMARY KEY CLUSTERED 
(
	[DriverId] ASC,
	[TruckId] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[LogisticsCenter]    Script Date: 8/6/2021 12:08:22 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[LogisticsCenter](
	[BranchId] [int] NOT NULL,
	[Address] [nvarchar](300) NULL,
 CONSTRAINT [PK_LogisticsCenter] PRIMARY KEY CLUSTERED 
(
	[BranchId] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Parking]    Script Date: 8/6/2021 12:08:22 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Parking](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[TruckParkId] [int] NOT NULL,
	[TruckId] [int] NOT NULL,
	[StartParking] [datetime] NOT NULL,
	[EndParking] [datetime] NULL,
	[ParkingSpaceColumn] [nchar](1) NOT NULL,
	[ParkingSpaceRow] [int] NOT NULL,
 CONSTRAINT [PK_Parking_1] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[RoadAction]    Script Date: 8/6/2021 12:08:22 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[RoadAction](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[ActionTypeId] [int] NOT NULL,
	[StartDateTime] [datetime] NOT NULL,
	[DriverId] [int] NULL,
	[TransportTaskId] [int] NOT NULL,
	[PlaceLongitude] [decimal](9, 6) NULL,
	[PlaceLatitude] [decimal](8, 6) NULL,
	[PlaceDescription] [nvarchar](100) NULL,
	[Comment] [nvarchar](max) NULL,
 CONSTRAINT [PK_RoadAction] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[TransportTask]    Script Date: 8/6/2021 12:08:22 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[TransportTask](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[CreatedDateTime] [datetime] NOT NULL,
	[ArrivalLogisticsCenterId] [int] NOT NULL,
	[DestinationLogisticsCenterId] [int] NOT NULL,
	[Deadline] [date] NULL,
	[TruckId] [int] NULL,
	[Comment] [nvarchar](max) NULL,
 CONSTRAINT [PK_TransportTask] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Truck]    Script Date: 8/6/2021 12:08:22 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Truck](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[TruckModelId] [int] NOT NULL,
	[Number] [nvarchar](10) NOT NULL,
	[CurrentLocationLatitude] [decimal](8, 6) NULL,
	[CurrentLocationLongitude] [decimal](9, 6) NULL,
	[CompetitorId] [int] NULL,
 CONSTRAINT [PK_Truck] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[TruckModel]    Script Date: 8/6/2021 12:08:22 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[TruckModel](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[Name] [nvarchar](50) NOT NULL,
	[VendorId] [int] NOT NULL,
	[TruckTypeId] [int] NOT NULL,
	[TankVolume] [int] NULL,
	[FuelConsumption] [int] NULL,
 CONSTRAINT [PK_TruckModel] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[TruckPark]    Script Date: 8/6/2021 12:08:22 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[TruckPark](
	[BranchId] [int] NOT NULL,
	[ColumnsCount] [int] NOT NULL,
	[RowsCount] [int] NOT NULL,
 CONSTRAINT [PK_TruckPark] PRIMARY KEY CLUSTERED 
(
	[BranchId] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[TruckType]    Script Date: 8/6/2021 12:08:22 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[TruckType](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[Name] [nvarchar](50) NOT NULL,
	[Picture] [image] NOT NULL,
 CONSTRAINT [PK_TruckType] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO
/****** Object:  Table [dbo].[TruckVendor]    Script Date: 8/6/2021 12:08:22 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[TruckVendor](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[Name] [nvarchar](50) NOT NULL,
 CONSTRAINT [PK_TruckVendor] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON, OPTIMIZE_FOR_SEQUENTIAL_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]
GO
ALTER TABLE [dbo].[ActionPhoto]  WITH CHECK ADD  CONSTRAINT [FK_ActionPhoto_RoadAction] FOREIGN KEY([RoadActionId])
REFERENCES [dbo].[RoadAction] ([Id])
GO
ALTER TABLE [dbo].[ActionPhoto] CHECK CONSTRAINT [FK_ActionPhoto_RoadAction]
GO
ALTER TABLE [dbo].[DriverOfTruck]  WITH CHECK ADD  CONSTRAINT [FK_DriverOfTruck_Driver] FOREIGN KEY([DriverId])
REFERENCES [dbo].[Driver] ([Id])
GO
ALTER TABLE [dbo].[DriverOfTruck] CHECK CONSTRAINT [FK_DriverOfTruck_Driver]
GO
ALTER TABLE [dbo].[DriverOfTruck]  WITH CHECK ADD  CONSTRAINT [FK_DriverOfTruck_Truck] FOREIGN KEY([TruckId])
REFERENCES [dbo].[Truck] ([Id])
GO
ALTER TABLE [dbo].[DriverOfTruck] CHECK CONSTRAINT [FK_DriverOfTruck_Truck]
GO
ALTER TABLE [dbo].[LogisticsCenter]  WITH CHECK ADD  CONSTRAINT [FK_LogisticsCenter_Branch] FOREIGN KEY([BranchId])
REFERENCES [dbo].[Branch] ([Id])
GO
ALTER TABLE [dbo].[LogisticsCenter] CHECK CONSTRAINT [FK_LogisticsCenter_Branch]
GO
ALTER TABLE [dbo].[Parking]  WITH CHECK ADD  CONSTRAINT [FK_Parking_Truck] FOREIGN KEY([TruckId])
REFERENCES [dbo].[Truck] ([Id])
GO
ALTER TABLE [dbo].[Parking] CHECK CONSTRAINT [FK_Parking_Truck]
GO
ALTER TABLE [dbo].[Parking]  WITH CHECK ADD  CONSTRAINT [FK_Parking_TruckPark] FOREIGN KEY([TruckParkId])
REFERENCES [dbo].[TruckPark] ([BranchId])
GO
ALTER TABLE [dbo].[Parking] CHECK CONSTRAINT [FK_Parking_TruckPark]
GO
ALTER TABLE [dbo].[RoadAction]  WITH CHECK ADD  CONSTRAINT [FK_RoadAction_ActionType] FOREIGN KEY([ActionTypeId])
REFERENCES [dbo].[ActionType] ([Id])
GO
ALTER TABLE [dbo].[RoadAction] CHECK CONSTRAINT [FK_RoadAction_ActionType]
GO
ALTER TABLE [dbo].[RoadAction]  WITH CHECK ADD  CONSTRAINT [FK_RoadAction_Driver] FOREIGN KEY([DriverId])
REFERENCES [dbo].[Driver] ([Id])
GO
ALTER TABLE [dbo].[RoadAction] CHECK CONSTRAINT [FK_RoadAction_Driver]
GO
ALTER TABLE [dbo].[RoadAction]  WITH CHECK ADD  CONSTRAINT [FK_RoadAction_TransportTask] FOREIGN KEY([TransportTaskId])
REFERENCES [dbo].[TransportTask] ([Id])
GO
ALTER TABLE [dbo].[RoadAction] CHECK CONSTRAINT [FK_RoadAction_TransportTask]
GO
ALTER TABLE [dbo].[TransportTask]  WITH CHECK ADD  CONSTRAINT [FK_TransportTask_LogisticsCenter] FOREIGN KEY([ArrivalLogisticsCenterId])
REFERENCES [dbo].[LogisticsCenter] ([BranchId])
GO
ALTER TABLE [dbo].[TransportTask] CHECK CONSTRAINT [FK_TransportTask_LogisticsCenter]
GO
ALTER TABLE [dbo].[TransportTask]  WITH CHECK ADD  CONSTRAINT [FK_TransportTask_LogisticsCenter1] FOREIGN KEY([DestinationLogisticsCenterId])
REFERENCES [dbo].[LogisticsCenter] ([BranchId])
GO
ALTER TABLE [dbo].[TransportTask] CHECK CONSTRAINT [FK_TransportTask_LogisticsCenter1]
GO
ALTER TABLE [dbo].[TransportTask]  WITH CHECK ADD  CONSTRAINT [FK_TransportTask_Truck] FOREIGN KEY([TruckId])
REFERENCES [dbo].[Truck] ([Id])
GO
ALTER TABLE [dbo].[TransportTask] CHECK CONSTRAINT [FK_TransportTask_Truck]
GO
ALTER TABLE [dbo].[Truck]  WITH CHECK ADD  CONSTRAINT [FK_Truck_TruckModel] FOREIGN KEY([TruckModelId])
REFERENCES [dbo].[TruckModel] ([Id])
GO
ALTER TABLE [dbo].[Truck] CHECK CONSTRAINT [FK_Truck_TruckModel]
GO
ALTER TABLE [dbo].[TruckModel]  WITH CHECK ADD  CONSTRAINT [FK_TruckModel_TruckType] FOREIGN KEY([TruckTypeId])
REFERENCES [dbo].[TruckType] ([Id])
GO
ALTER TABLE [dbo].[TruckModel] CHECK CONSTRAINT [FK_TruckModel_TruckType]
GO
ALTER TABLE [dbo].[TruckModel]  WITH CHECK ADD  CONSTRAINT [FK_TruckModel_TruckVendor] FOREIGN KEY([VendorId])
REFERENCES [dbo].[TruckVendor] ([Id])
GO
ALTER TABLE [dbo].[TruckModel] CHECK CONSTRAINT [FK_TruckModel_TruckVendor]
GO
ALTER TABLE [dbo].[TruckPark]  WITH CHECK ADD  CONSTRAINT [FK_TruckPark_Branch] FOREIGN KEY([BranchId])
REFERENCES [dbo].[Branch] ([Id])
GO
ALTER TABLE [dbo].[TruckPark] CHECK CONSTRAINT [FK_TruckPark_Branch]
GO
